#!/usr/local/bin/perl -wT
# Copyright Andru Luvisi, 1999
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program (see the file COPYING); if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA


use CGI;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;
use strict;

use vars qw($query $template $unscrambled @unscrambled @scrambled);

$query = CGI->new();
$unscrambled = $query->param("unscrambled");
@unscrambled = split(/[\n\r]+/, $unscrambled);
@scrambled = map { { "scrambled" => scramble($_) }; } @unscrambled;
@unscrambled = map { { "unscrambled" => $_ }; } @unscrambled;
$template = HTML::Template->new(filename => "scramble.tmpl",
				die_on_bad_params => 0);
$template->param("unscrambled_list", \@unscrambled);
$template->param("scrambled_list", \@scrambled);
print $query->header(), $template->output(), "\n";
exit(0);

sub scramble {
    my $phrase = shift;
    my @spaces = ();
    my @letters = ();

    while($phrase =~ s/^([^ ]*) /$1/) {
	push @spaces, length($1);
    }

    @letters = split(//, $phrase);
    fyshuffle(\@letters);
    $phrase = join("", @letters);

    while(@spaces) {
	substr($phrase, pop(@spaces), 0) = " ";
    }

    return $phrase;
}

sub fyshuffle {
 my($array) = shift;
 my $i;

 for($i = @$array; --$i;) {
  my($j) = int(rand($i+1));
  next if $i == $j;
  @$array[$i,$j] = @$array[$j,$i];
 }
}

